/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.portal.lpkg.deployer.internal;

import java.io.IOException;

import java.net.URL;
import java.net.URLConnection;

import java.util.Map;

import org.osgi.service.url.AbstractURLStreamHandlerService;

/**
 * @author Shuyang Zhou
 */
public class LPKGURLStreamHandlerService
	extends AbstractURLStreamHandlerService {

	public LPKGURLStreamHandlerService(Map<String, URL> urls) {
		_urls = urls;
	}

	@Override
	public URLConnection openConnection(URL lpkgURL) throws IOException {
		URL url = _urls.get(lpkgURL.toExternalForm());

		if (url == null) {
			throw new IllegalArgumentException("Unknown LPKG URL " + lpkgURL);
		}

		return url.openConnection();
	}

	private final Map<String, URL> _urls;

}